<?php

namespace Mergado\Tools\XML;

use Exception;
use Mergado\Tools\XMLProductFeed;

include_once __MERGADO_DIR__ . 'autoload.php';

class ProductFeedItem
{
    // XML PROPERTIES
    public $itemId;
    public $availability;
    public $url;
    public $nameExact; //CDATA
    public $currency;
    public $vat;
    public $price;
    public $priceVat;
    public $priceDiscount;
    public $priceDiscountVat;
    public $salePriceEffectiveDate;
    public $image;
    public $imageAlternative;
    public $param;
    public $stockQuantity;
    public $description;
    public $descriptionShort;
    public $category;
    public $ean;
    public $shippingSize;
    public $shippingWeight;
    public $itemgroupId;
    public $productno;
    public $variantDescription;
    public $customProperties = null;

    private $xml;
    private $productType;

    public function __construct($xml, $productType)
    {
        $this->xml = $xml;
        $this->productType = $productType;
    }

    public function __set($name, $value) {
        throw new Exception("Cannot add new property \$$name to instance of " . __CLASS__ . '. Use set methods instead!');
    }

    /**
     * @return mixed
     */
    public function getItemId()
    {
        return $this->itemId;
    }

    /**
     * @param mixed $itemId
     */
    public function setItemId($itemId)
    {
        $this->itemId = $itemId;
    }

    /**
     * @return mixed
     */
    public function getAvailability()
    {
        return $this->availability;
    }

    /**
     * @param mixed $availability
     */
    public function setAvailability($availability)
    {
        $this->availability = $availability;
    }

    /**
     * @return mixed
     */
    public function getUrl()
    {
        return $this->url;
    }

    /**
     * @param mixed $url
     */
    public function setUrl($url)
    {
        $this->url = $url;
    }

    /**
     * @return mixed
     */
    public function getNameExact()
    {
        return $this->nameExact;
    }

    /**
     * @param mixed $nameExact
     */
    public function setNameExact($nameExact)
    {
        $this->nameExact = $nameExact;
    }

    /**
     * @return mixed
     */
    public function getCurrency()
    {
        return $this->currency;
    }

    /**
     * @param mixed $currency
     */
    public function setCurrency($currency)
    {
        $this->currency = $currency;
    }

    /**
     * @return mixed
     */
    public function getVat()
    {
        return $this->vat;
    }

    /**
     * @param mixed $vat
     */
    public function setVat($vat)
    {
        $this->vat = $vat;
    }

    /**
     * @return mixed
     */
    public function getPrice()
    {
        return $this->price;
    }

    /**
     * @param mixed $price
     */
    public function setPrice($price)
    {
        $this->price = $price;
    }

    /**
     * @return mixed
     */
    public function getPriceVat()
    {
        return $this->priceVat;
    }

    /**
     * @param mixed $priceVat
     */
    public function setPriceVat($priceVat)
    {
        $this->priceVat = $priceVat;
    }

    /**
     * @return mixed
     */
    public function getPriceDiscount()
    {
        return $this->priceDiscount;
    }

    /**
     * @param mixed $priceDiscount
     */
    public function setPriceDiscount($priceDiscount)
    {
        $this->priceDiscount = $priceDiscount;
    }

    /**
     * @return mixed
     */
    public function getPriceDiscountVat()
    {
        return $this->priceDiscountVat;
    }

    /**
     * @param mixed $priceDiscountVat
     */
    public function setPriceDiscountVat($priceDiscountVat)
    {
        $this->priceDiscountVat = $priceDiscountVat;
    }

    /**
     * @return mixed
     */
    public function getSalePriceEffectiveDate()
    {
        return $this->salePriceEffectiveDate;
    }

    /**
     * @param mixed $salePriceEffectiveDate
     */
    public function setSalePriceEffectiveDate($salePriceEffectiveDate)
    {
        $this->salePriceEffectiveDate = $salePriceEffectiveDate;
    }

    /**
     * @return mixed
     */
    public function getImage()
    {
        return $this->image;
    }

    /**
     * @param mixed $image
     */
    public function setImage($image)
    {
        $this->image = $image;
    }

    /**
     * @return array|null
     */
    public function getImageAlternative(): ?array
    {
        return $this->imageAlternative;
    }

    /**
     * @param array|null $imageAlternative
     */
    public function setImageAlternative(?array $imageAlternative)
    {
        $this->imageAlternative = $imageAlternative;
    }

    /**
     * @return mixed
     */
    public function getParam()
    {
        return $this->param;
    }

    /**
     * @param mixed $param
     */
    public function setParam($param)
    {
        $this->param = $param;
    }

    /**
     * @return mixed
     */
    public function getStockQuantity()
    {
        return $this->stockQuantity;
    }

    /**
     * @param mixed $stockQuantity
     */
    public function setStockQuantity($stockQuantity)
    {
        $this->stockQuantity = $stockQuantity;
    }

    /**
     * @return mixed
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * @param mixed $description
     */
    public function setDescription($description)
    {
        $this->description = $description;
    }

    /**
     * @return mixed
     */
    public function getDescriptionShort()
    {
        return $this->descriptionShort;
    }

    /**
     * @param mixed $descriptionShort
     */
    public function setDescriptionShort($descriptionShort)
    {
        $this->descriptionShort = $descriptionShort;
    }

    /**
     * @return mixed
     */
    public function getCategory()
    {
        return $this->category;
    }

    /**
     * @param mixed $category
     */
    public function setCategory($category)
    {
        $this->category = $category;
    }

    /**
     * @return mixed
     */
    public function getEan()
    {
        return $this->ean;
    }

    /**
     * @param mixed $ean
     */
    public function setEan($ean)
    {
        $this->ean = $ean;
    }

    /**
     * @return mixed
     */
    public function getShippingSize()
    {
        return $this->shippingSize;
    }

    /**
     * @param mixed $shippingSize
     */
    public function setShippingSize($shippingSize)
    {
        $this->shippingSize = $shippingSize;
    }

    /**
     * @return mixed
     */
    public function getShippingWeight()
    {
        return $this->shippingWeight;
    }

    /**
     * @param mixed $shippingWeight
     */
    public function setShippingWeight($shippingWeight)
    {
        $this->shippingWeight = $shippingWeight;
    }

    /**
     * @return mixed
     */
    public function getItemgroupId()
    {
        return $this->itemgroupId;
    }

    /**
     * @param mixed $itemgroupId
     */
    public function setItemgroupId($itemgroupId)
    {
        $this->itemgroupId = $itemgroupId;
    }

    /**
     * @return mixed
     */
    public function getProductno()
    {
        return $this->productno;
    }

    /**
     * @param mixed $productno
     */
    public function setProductno($productno)
    {
        $this->productno = $productno;
    }

    /**
     * @return mixed
     */
    public function getVariantDescription()
    {
        return $this->variantDescription;
    }

    /**
     * @param mixed $variantDescription
     */
    public function setVariantDescription($variantDescription)
    {
        $this->variantDescription = $variantDescription;
    }

    public function getXmlItem() {
        $item = $this->xml->createElement('ITEM');

        $this->createXmlItemProperty($item, 'ITEM_ID', $this->getItemId());
        $this->createXmlItemProperty($item, 'AVAILABILITY', $this->getAvailability());
        $this->createXmlItemProperty($item, 'URL', $this->getUrl());
        $this->createXmlItemProperty($item, 'NAME_EXACT', $this->getNameExact(), true);
        $this->createXmlItemProperty($item, 'CURRENCY', $this->getCurrency());
        $this->createXmlItemProperty($item, 'VAT', $this->getVat());
        $this->createXmlItemProperty($item, 'PRICE', $this->getPrice());
        $this->createXmlItemProperty($item, 'PRICE_VAT', $this->getPriceVat());
        $this->createXmlItemProperty($item, 'PRICE_DISCOUNT', $this->getPriceDiscount());
        $this->createXmlItemProperty($item, 'PRICE_DISCOUNT_VAT', $this->getPriceDiscountVat());
        $this->createXmlItemProperty($item, 'SALE_PRICE_EFFECTIVE_DATE', $this->getSalePriceEffectiveDate());
        $this->createXmlItemProperty($item, 'IMAGE', $this->getImage());
        $this->createXmlItemPropertyArray($item, 'IMAGE_ALTERNATIVE', $this->getImageAlternative());
        $this->createXmlParam($item, $this->getParam());
        $this->createXmlItemProperty($item, 'STOCK_QUANTITY', $this->getStockQuantity());
        $this->createXmlItemProperty($item, 'DESCRIPTION', $this->getDescription(), true, true);
        $this->createXmlItemProperty($item, 'DESCRIPTION_SHORT', $this->getDescriptionShort(), true, true);
        $this->createXmlItemProperty($item, 'CATEGORY', $this->getCategory(), true);
        $this->createXmlItemProperty($item, 'EAN', $this->getEan());
        $this->createXmlItemProperty($item, 'SHIPPING_SIZE', $this->getShippingSize());
        $this->createXmlItemProperty($item, 'SHIPPING_WEIGHT', $this->getShippingWeight());
        $this->createXmlItemProperty($item, 'ITEMGROUP_ID', $this->getItemgroupId());
        $this->createXmlItemProperty($item, 'PRODUCTNO', $this->getProductno(), true);

        if (XMLProductFeed::is_product_type($this->productType, 'variation')) {
            $this->createXmlItemProperty($item, 'VARIANT_DESCRIPTION', $this->getVariantDescription(), true, true);
        }

        if ($this->getCustomProperties() !== null) {
            foreach($this->getCustomProperties() as $customPropertyKey => $customPropertyValue) {
                $this->createCustomProperties($item, $customPropertyKey, $customPropertyValue);
            }
        }

        return $item;
    }

    /**
     *     /**
     * $customProperties should be ARRAY in one of following formats
     *
     * =======================
     * === Simple property ===
     * =======================
     *
     * ['propertyName' => 'propertyValue']
     *
     * =======================
     * === Nested property ===
     * =======================
     *
     * ['propertyName' => ['propertyName' => 'propertyValue']]
     *
     * =========================================================
     * === Multi-nested property (infinite nesting possible) ===
     * =========================================================
     *
     * ['propertyName' => ['propertyName' => ['propertyName' => 'propertyValue']]]
     *
     *
     * IMPORTANT INFO: Values that contains something that XML parser can read as markup should be wrapped in <![CDATA[]]>
     *
     * @param $item
     * @param $name
     * @param $value
     * @return mixed
     */
    private function createCustomProperties(&$item, $name, $value) {
        if (is_array($value)) {
            $element = $this->xml->createElement($name);

            foreach($value as $propName => $propValue) {
                $element->appendChild($this->createCustomProperties($element, $propName, $propValue));
            }


            return $item->appendChild($element);
        } else {
            return $item->appendChild($this->xml->createElement($name, $value));
        }
    }

    /**
     * @param $item
     * @param $name
     * @param $value
     * @param bool $sanitizeCData
     * @return mixed
     */
    private function createXmlItemProperty($item, $name, $value, bool $sanitizeCData = false, $showIfEmpty = false) {
        if (trim($value) === '' && !$showIfEmpty) {
            return false;
        }

        if ($sanitizeCData) {
            $element = $this->xml->createElement($name);
            $element->appendChild($this->xml->createCDATASection($value));
            $item->appendChild($element);
        } else {
            $item->appendChild($this->xml->createElement($name, $value));
        }

        return $item;
    }

    /**
     * @param $item
     * @param $name
     * @param $values
     * @param bool $sanitizeCData
     * @return mixed|void
     */
    private function createXmlItemPropertyArray($item, $name, $values, bool $sanitizeCData = false) {
        if (!is_array($values) || count($values) <= 0) {
            return false;
        }

        foreach ($values as $value) {
            if ($sanitizeCData) {
                $element = $this->xml->createElement($name);
                $element->appendChild($this->xml->createCDATASection($value));
                $item->appendChild($element);
            } else {
                $item->appendChild($this->xml->createElement($name, $value));
            }
        }

        return $item;
    }

    /**
     * @param $item
     * @param $values
     * @return mixed|void
     */
    private function createXmlParam($item, $values) {
        if (!is_array($values) || count($values) <= 0) {
            return false;
        }

        foreach ($values as $value) {
            $param = $this->xml->createElement('PARAM');
            $paramName = $this->xml->createElement('NAME');
            $paramValue = $this->xml->createElement('VALUE');

            $paramName->appendChild($this->xml->createCDATASection($value['name']));
            $paramValue->appendChild($this->xml->createCDATASection($value['value']));

            $param->appendChild($paramName);
            $param->appendChild($paramValue);

            $item->appendChild($param);
        }

        return $item;
    }

    /**
     * @return mixed
     */
    public function getCustomProperties()
    {
        return $this->customProperties;
    }

    /**
     * @param array $customProperties
     * @return void
     */
    public function setCustomProperties(array $customProperties): void
    {
        $this->customProperties = $customProperties;
    }
}
